#from ___INIT import *

import math


class Planfraesen():
    def __init__(self, durchmesserFraeser, schnittBreiteAe, startPosX, startPosY, sichereHoeheZ, laengeX, laengeY,
                 schnittTiefeEinzelschnitt, schlichtAufmassZ, startTiefeZ, endTiefeZ, ueberlauf, vorschubSchruppen,
                 vorschubSchlichten, drehzahlSchruppen, drehzahlSchlichten):

        self.durchmesserFraeser = durchmesserFraeser
        if (self.durchmesserFraeser <= 0):
            msg.err("Fräserdurchmesser muss größer 0 sein!!!\n ")
            sys.exit("\n Es kann keine Fräsbahn berechnet werden!\n Fräserdurchmesser ändern!")
        self.schnittBreiteAe = schnittBreiteAe
        if (self.schnittBreiteAe > self.durchmesserFraeser):
            msg.err("Schnittbreite ae muss kleiner gleich Fraeserdurchmesser sein!!!\n ")
            sys.exit("\n Es kann keine Fräsbahn berechnet werden!")
        self.startPosX = startPosX
        self.startPosY = startPosY
        self.sichereHoeheZ = sichereHoeheZ
        self.laengeX = laengeX
        if (self.laengeX <= 0):
            msg.err("Länge in X muss größer 0 sein!!!\n ")
            sys.exit("\n Es kann keine Fräsbahn berechnet werden!\n Länge X ändern!")
        self.laengeY = laengeY
        if (self.laengeX <= 0):
            msg.err("Länge in X muss größer 0 sein!!!\n ")
            sys.exit("\n Es kann keine Fräsbahn berechnet werden!\n Länge X ändern!")
        self.startTiefeZ = startTiefeZ
        if (self.startTiefeZ >= self.sichereHoeheZ):
            msg.err("Die sichere Höhe in Z muss oberhalb der Starthoehe in Z liegen!!!\n ")
            sys.exit("\n Es kann keine Fräsbahn berechnet werden!\n Hoehen  ändern!")
        self.aktuelleTiefeZ = startTiefeZ
        self.starttTefeZsicher = startTiefeZ + 2
        self.endTiefeZ = endTiefeZ
        if (self.endTiefeZ >= self.startTiefeZ):
            msg.err("Starttiefe in Z muss größer sein als die  Endtiefe in Z!!!\n ")
            sys.exit("\n Es kann keine Fräsbahn berechnet werden!\n Tiefen anpassen")
        self.schnittTiefeGesamt = startTiefeZ - endTiefeZ
        self.schnittTiefeEinzelschnitt = schnittTiefeEinzelschnitt
        self.schlichtAufmassZ = schlichtAufmassZ
        if gui.pf_cbx_schlichten.getCheckboxState() == False:
            self.schlichtAufmassZ = 0
        self.schnitttiefeSchruppen = self.schnittTiefeGesamt - self.schlichtAufmassZ
        self.anzahlTiefenschnitteSchruppen = math.ceil(self.schnitttiefeSchruppen * 1.0 / schnittTiefeEinzelschnitt)
        self.schnittTiefeEinzelschnittBerechnet = self.schnitttiefeSchruppen / self.anzahlTiefenschnitteSchruppen
        self.schnittTiefeLetzterTiefenschnittSchruppen = self.endTiefeZ + schlichtAufmassZ

        # wie weit soll der Fräser in X über das Werkstück hinaus fahren
        self.ueberlauf = ueberlauf
        if ueberlauf < 0:
            self.ueberlauf = self.ueberlauf * -1
            msg.info("Der Überlauf muss größer oder gleich 0 sein.\n Setze Überlauf auf " + str(self.ueberlauf))
            d.setMachineParam( 110, self.ueberlauf)


        # Anzahl der Bahnen berechnen
        # self.anzahlBahnen = math.ceil((self.laengeY - self.schnittBreiteAe) / self.schnittBreiteAe )
        self.anzahlBahnen = self.berechneAnzahlQuerzustellungen()

        self.vorschubSchruppen = vorschubSchruppen
        self.vorschubSchlichten = vorschubSchlichten
        self.drehzahlSchruppen = drehzahlSchruppen
        self.drehzahlSchlichten = drehzahlSchlichten

        # G_Code: String zum Speichern des G-Codes
        self.G_Code = "%\n(Planfraesen)\nG90 G94 G17 G49 G40 \nG21\nT1 M06\n"
        self.G_Code += "S" + str(self.drehzahlSchruppen) + " M03\nG54\n"

    def fahreZurStarposition(self):
        self.G_Code += "(Auf sichere Startposition fahren)\n"
        self.fahreAufSicheresZ()
        self.G_Code += "G00 x" + str(self.startPosX - self.durchmesserFraeser - self.ueberlauf) + " y" + str(
            self.startPosY - self.durchmesserFraeser) + "\n"
        self.G_Code += "G01 z" + str(self.aktuelleTiefeZ) + " f" + str(self.vorschubSchruppen) + "\n"

    def planen(self):
        durchgang = 0
        posX = self.startPosX - self.durchmesserFraeser - self.ueberlauf
        # posY = self.startPosY + (self.durchmesserFraeser/2) - (self.durchmesserFraeser - self.schnittBreiteAe) -self.schnittBreiteAe
        posY = self.startPosY + (self.schnittBreiteAe - self.durchmesserFraeser / 2) - self.schnittBreiteAe
        while durchgang <= self.anzahlBahnen:
            durchgang += 1
            # Zustellung in y-Richtung
            posY = posY + self.schnittBreiteAe
            self.G_Code += "G01 x" + str(posX) + " y" + str(posY) + "\n"
            if posX < self.startPosX:
                posX = self.startPosX + self.laengeX + self.durchmesserFraeser + self.ueberlauf
            else:
                posX = self.startPosX - self.durchmesserFraeser - self.ueberlauf
            # Bahn in x-Richtung fräsen
            self.G_Code += "G01 x" + str(posX) + " y" + str(posY) + "\n"

        # self.G_Code += "M09\nG53 G00 Z50\nG49\nG53 G00 x0 y0\nM30\n%"

    def fahreAufSicheresZ(self):
        self.G_Code += "G00 z" + str(self.sichereHoeheZ) + "\n"

    def fahreAussenkonturWerkstueck(self):
        self.G_Code += "(Werstueckabmessungen)\n"
        self.G_Code += "\nG00 z" + str(self.sichereHoeheZ)
        self.G_Code += "\nG00 x" + str(self.startPosX) + " y" + str(self.startPosY)
        self.G_Code += "\nG00 x" + str(self.startPosX + self.laengeX)
        self.G_Code += "\nG00 y" + str(self.startPosY + self.laengeY)
        self.G_Code += "\nG00 x" + str(self.startPosX)
        self.G_Code += "\nG00 x" + str(self.startPosX) + " y" + str(self.startPosY) + "\n"

    def berechneAnzahlQuerzustellungen(self):
        anzahlquerzustellungen = 1;
        y = self.schnittBreiteAe
        while y + self.schnittBreiteAe < self.laengeY:
            anzahlquerzustellungen += 1
            y += self.schnittBreiteAe
        return anzahlquerzustellungen


# -----------Werte aus GUI holen ---------------------------------
durchmesserFraeser = float(gui.pf_txt_Fraeserdurchmesser.getText())
schnittBreiteAe = float(gui.pf_txt_SchnittbreiteAe.getText())
startPosX = float(gui.pf_txt_StartpositionX.getText())
startPosY = float(gui.pf_txt_StartpositionY.getText())
sichereHoeheZ = float(gui.pf_txt_SichereHoehe.getText())
laengeX = float(gui.pf_txt_WerckstuecklaengeX.getText())
laengeY = float(gui.pf_txt_WerckstuecklaengeY.getText())
schnittTiefeEinzelschnittAp = float(gui.pf_txt_SchnitttiefAp.getText())
schlichtAufmassZ = float(gui.pf_txt_SchlichtaufmassZ.getText())
startTiefeZ = float(gui.pf_txt_StarttiefeZ.getText())
endTiefeZ = float(gui.pf_txt_EndtiefeZ.getText())
ueberlauf = float(gui.pf_txt_Ueberlauf.getText())
vorschubSchruppen = int(gui.pf_txt_VorschubSchruppen.getText())
vorschubSchlichten = int(gui.pf_txt_VorschubSchlichten.getText())
drehzahlSchruppen = int(gui.pf_txt_DrehzahlSchruppen.getText())
drehzahlSchlichten = int(gui.pf_txt_DrehzahlSchlichten.getText())

#Wurde eien Datei ausgewählt?
if gui.pf_txt_DateiPfad.getText() == "":
    msg.err(
        "Sie müssen eine vorhandene .nc - Datei auswählen!!!\n Achtung: Die ausgewälte Datei wird mit dem neuen G-Code überschrieben.")
    sys.exit("\n Es kann keine Fräsbahn berechnet werden!\n Datei auswählen!")

# Planfräsen-Objekt erzeugen und Methoden aufrufen --------------------------------------------------
planFraesen = Planfraesen(durchmesserFraeser, schnittBreiteAe, startPosX, startPosY, sichereHoeheZ, laengeX, laengeY,
                          schnittTiefeEinzelschnittAp, schlichtAufmassZ, startTiefeZ, endTiefeZ, ueberlauf,
                          vorschubSchruppen, vorschubSchlichten, drehzahlSchruppen, drehzahlSchlichten)


print(">>>  Starte Bahnberechnung Planfräsen    <<<")
# planFraesen.fahreAussenkonturWerkstueck()
ebene = 0
while planFraesen.aktuelleTiefeZ >= planFraesen.endTiefeZ + planFraesen.schnittTiefeEinzelschnittBerechnet:
    ebene += 1
    planFraesen.aktuelleTiefeZ = planFraesen.aktuelleTiefeZ - planFraesen.schnittTiefeEinzelschnittBerechnet
    #print(str(planFraesen.aktuelleTiefeZ))
    planFraesen.fahreZurStarposition()
    planFraesen.G_Code += "G01 s" + str(planFraesen.drehzahlSchruppen) + " f" + str(
        planFraesen.vorschubSchruppen) + "\n"
    planFraesen.G_Code += "(Starte Planen Ebene " + str(ebene) + ")\n"
    planFraesen.planen()

# Schlichtspan evtl. auch letzter Span
if planFraesen.aktuelleTiefeZ > planFraesen.endTiefeZ:
    schlichtspanStaerke = planFraesen.endTiefeZ - planFraesen.aktuelleTiefeZ
    planFraesen.aktuelleTiefeZ = planFraesen.endTiefeZ
    planFraesen.fahreZurStarposition()
    if gui.pf_cbx_schlichten.getCheckboxState():
        planFraesen.G_Code += "(Starte Schlichten Zustellung " + str(round(schlichtspanStaerke, 2)) + "mm)\n"
    else:
        planFraesen.G_Code += "(Starte letzte Zustellung " + str(round(schlichtspanStaerke, 2)) + "mm)\n"
    planFraesen.planen()

planFraesen.G_Code += "M09\nG00 Z" + str(planFraesen.sichereHoeheZ) + "\nG49\nG28\nM30\n%"

# Dateipfad - Hier wird der erzeugte G-Code gespeichert
cncFilePath = gui.pf_txt_DateiPfad.getText();

try:
    File = open(cncFilePath, "w")
except IOError:
    sys.exit("\n No access to file !!!\n" + cncFilePath)

# Den String planFraesen.G_Code in Datei schreiben
try:
    File.write(planFraesen.G_Code)
    File.close()
    # G-Code aus erzeugten Datei laden
    d.openGCodeFile(cncFilePath)
    print("---      CNC-Programm erfolgreich erstellt!      ---")
    print(">>>  klicken Sie auf Yes (G-Code neu laden)  <<<\n")

except IOError:
    File.close()
    sys.exit("\n File write error !!!")

# Das CNC-Programm in der Konsole ausgeben
# print(planFraesen.G_Code)
