import time
import math

probeIndex = 0
fineProbingDelay=0.3
fineProbeMaxAllowedDiff= 0.1
moveBackDistance= 0.5
checkFineProbingDiff = True
ballDiameter=float(d.getMachineParam(0))
fastProbeSpeed=float(d.getMachineParam(1))
slowProbeSpeed=float(d.getMachineParam(2))
searchDistance=float(d.getMachineParam(3))
xYClearance=float(d.getMachineParam(4))
edgeOffset=float(d.getMachineParam(5))

autoRotate=float(d.getMachineParam(7))
toolChangePosX=float(d.getMachineParam(8))
toolChangePosY=float(d.getMachineParam(9))
autoRotate=float(d.getMachineParam(7))

def probeXPlus():

    print("X+ probing start")
    pos = d.getPosition(CoordMode.Machine)
    # start fast probing
    pos[Axis.X.value] =  pos[Axis.X.value]+searchDistance
    probeResult = d.executeProbing(CoordMode.Machine, pos,probeIndex,fastProbeSpeed)
    if(probeResult == False):
      sys.exit("fast probing failed!")
    # get fast probe contact position
    fastProbeFinishPos = d.getProbingPosition(CoordMode.Machine)

    d.moveAxisIncremental(Axis.X, -moveBackDistance,fastProbeSpeed)
    # delay
    time.sleep(fineProbingDelay)
    # start fine probing
    probeResult = d.executeProbing(CoordMode.Machine, pos, probeIndex,slowProbeSpeed)
    if(probeResult == False):
     sys.exit("slow probing failed!")
    # get fine probe contact position
    probeFinishPos = d.getProbingPosition(CoordMode.Machine)

    # check diff between fast and fine probing
    probeDiff = abs(fastProbeFinishPos[Axis.X.value] - probeFinishPos[Axis.X.value])
    if(probeDiff > fineProbeMaxAllowedDiff and checkFineProbingDiff == True):
     errMsg = "ERROR: fine probing difference limit exceeded! (diff: {:.3f})".format(probeDiff)
     sys.exit( errMsg)

    print("sucess x+: {:.3f}".format(  probeFinishPos[0]))
    d.moveAxisIncremental( Axis.X,-moveBackDistance,fastProbeSpeed)
    
    probeFinishPos[0]=probeFinishPos[0]+ballDiameter/2
  
    return probeFinishPos
  
def probeXMinus():
    pos = d.getPosition(CoordMode.Machine)
    # start fast probing
    pos[Axis.X.value] =  pos[Axis.X.value]-searchDistance
    probeResult = d.executeProbing(CoordMode.Machine, pos,probeIndex,fastProbeSpeed)
    if(probeResult == False):
      sys.exit("fast probing failed!")
    # get fast probe contact position
    fastProbeFinishPos = d.getProbingPosition(CoordMode.Machine)

    d.moveAxisIncremental(Axis.X, +moveBackDistance,fastProbeSpeed)
    # delay
    time.sleep(fineProbingDelay)
    # start fine probing
    probeResult = d.executeProbing(CoordMode.Machine, pos, probeIndex,slowProbeSpeed)
    if(probeResult == False):
     sys.exit("slow probing failed!")
    # get fine probe contact position
    probeFinishPos = d.getProbingPosition(CoordMode.Machine)

    # check diff between fast and fine probing
    probeDiff = abs(fastProbeFinishPos[Axis.X.value] - probeFinishPos[Axis.X.value])
    if(probeDiff > fineProbeMaxAllowedDiff and checkFineProbingDiff == True):
     errMsg = "ERROR: fine probing difference limit exceeded! (diff: {:.3f})".format(probeDiff)
     sys.exit( errMsg)

  
    
    print("sucess x-: {:.3f}".format(  probeFinishPos[0]))
    d.moveAxisIncremental( Axis.X,+moveBackDistance,fastProbeSpeed )
    probeFinishPos[0]=  probeFinishPos[0]-ballDiameter/2
    return  probeFinishPos

def probeYPlus():
    pos = d.getPosition(CoordMode.Machine)
    # start fast probing
    pos[Axis.Y.value] =  pos[Axis.Y.value]+searchDistance
    probeResult = d.executeProbing(CoordMode.Machine, pos,probeIndex,fastProbeSpeed)
    if(probeResult == False):
      sys.exit("fast probing failed!")
    # get fast probe contact position
    fastProbeFinishPos = d.getProbingPosition(CoordMode.Machine)

    d.moveAxisIncremental(Axis.Y, -moveBackDistance,fastProbeSpeed)
    # delay
    time.sleep(fineProbingDelay)
    # start fine probing
    probeResult = d.executeProbing(CoordMode.Machine, pos, probeIndex,slowProbeSpeed)
    if(probeResult == False):
     sys.exit("slow probing failed!")
    # get fine probe contact position
    probeFinishPos = d.getProbingPosition(CoordMode.Machine)

    # check diff between fast and fine probing
    probeDiff = abs(fastProbeFinishPos[Axis.Y.value] - probeFinishPos[Axis.Y.value])
    if(probeDiff > fineProbeMaxAllowedDiff and checkFineProbingDiff == True):
     errMsg = "ERROR: fine probing difference limit exceeded! (diff: {:.3f})".format(probeDiff)
     sys.exit( errMsg)

   
    
    print("sucess y+: {:.3f}".format(  probeFinishPos[1]))
    d.moveAxisIncremental( Axis.Y,-moveBackDistance,fastProbeSpeed )
    probeFinishPos[1]=  probeFinishPos[1]+ballDiameter/2
    return  probeFinishPos   

def probeYMinus():
    pos = d.getPosition(CoordMode.Machine)
    # start fast probing
    pos[Axis.Y.value] =  pos[Axis.Y.value]-searchDistance
    probeResult = d.executeProbing(CoordMode.Machine, pos,probeIndex,fastProbeSpeed)
    if(probeResult == False):
      sys.exit("fast probing failed!")
    # get fast probe contact position
    fastProbeFinishPos = d.getProbingPosition(CoordMode.Machine)

    d.moveAxisIncremental(Axis.Y, +moveBackDistance,fastProbeSpeed)
    # delay
    time.sleep(fineProbingDelay)
    # start fine probing
    probeResult = d.executeProbing(CoordMode.Machine, pos, probeIndex,slowProbeSpeed)
    if(probeResult == False):
     sys.exit("slow probing failed!")
    # get fine probe contact position
    probeFinishPos = d.getProbingPosition(CoordMode.Machine)

    # check diff between fast and fine probing
    probeDiff = abs(fastProbeFinishPos[Axis.Y.value] - probeFinishPos[Axis.Y.value])
    if(probeDiff > fineProbeMaxAllowedDiff and checkFineProbingDiff == True):
     errMsg = "ERROR: fine probing difference limit exceeded! (diff: {:.3f})".format(probeDiff)
     sys.exit( errMsg)

   
    
    print("sucess y-: {:.3f}".format(probeFinishPos[1]))
    d.moveAxisIncremental( Axis.Y,+moveBackDistance,fastProbeSpeed )
    probeFinishPos[1]=probeFinishPos[1]-ballDiameter/2
    return   probeFinishPos


def setAxisProgX(position):
    
    actualPos=d.getPosition(CoordMode.Machine)
    print(actualPos[0])
    newProgPos=actualPos[0]-position
    d.setAxisProgPosition( Axis.X, newProgPos)
    print(newProgPos)

def setAxisProgY(position):
    actualPos=d.getPosition(CoordMode.Machine)
    print(actualPos[1])
    newProgPos=actualPos[1]-position
    d.setAxisProgPosition( Axis.Y, newProgPos)
    print(newProgPos)    


def middleBetweenPoints(p1,p2):
    distance=p2-p1
    print('Pocket x size:')
    print(distance)
    return p1+(distance/2)


def circleMiddle(p1, p2, p3):
    """
    Returns the center and radius of the circle passing the given 3 points.
    In case the 3 points form a line, returns (None, infinity).
    """
    temp = p2[0] * p2[0] + p2[1] * p2[1]
    bc = (p1[0] * p1[0] + p1[1] * p1[1] - temp) / 2
    cd = (temp - p3[0] * p3[0] - p3[1] * p3[1]) / 2
    det = (p1[0] - p2[0]) * (p2[1] - p3[1]) - (p2[0] - p3[0]) * (p1[1] - p2[1])

    if abs(det) < 1.0e-6:
        return ("Error sorry try again")

    # Center of circle
    cx = (bc*(p2[1] - p3[1]) - cd*(p1[1] - p2[1])) / det
    cy = ((p1[0] - p2[0]) * cd - (p2[0] - p3[0]) * bc) / det

    radius = math.sqrt((cx - p1[0])**2 + (cy - p1[1])**2)
    return (cx,cy, radius)


def line_intersection(lineX, lineY):
    xdiff = (lineX[0][0] - lineX[1][0], lineY[0][0] - lineY[1][0])
    ydiff = (lineX[0][1] - lineX[1][1], lineY[0][1] - lineY[1][1]) 

    def det(a, b):
        return a[0] * b[1] - a[1] * b[0]

    div = det(xdiff, ydiff)
    if div == 0:
       raise Exception('lines do not intersect')

    d = (det(*lineX), det(*lineY))
    x = det(d, xdiff) / div
    y = det(d, ydiff) / div
    print(x)
    print(y)
    return [x, y]

def rotationAngle(p1, p2) -> float:
    """Get the angle of this line with the horizontal axis."""
    dx = p2[0] - p1[0]
    dy = p2[1] - p1[1]
    theta = math.atan2(dy, dx)
    angle = math.degrees(theta)  # angle is in (-180, 180]
    #if angle < 0:
    #    angle = 360 + angle

    print("angel=" + str(angle))

    d.setMachineParam(6,angle)

    if autoRotate:
        gCodeAngleRotation="G68 X0 Y0 R"+str(angle)
        d.executeGCode( gCodeAngleRotation)
   
    return angle

def resetG68():
     d.executeGCode("G69")