exec(open('screens/SmuQScreen/scripts/functions.py', encoding='utf-8').read())
import sys
import time

# Taster oder WLS auf/ über den Werkstück platzieren


probeIndex = 0

#search distance
searcheDistance =10		#Strecke in der in z gesucht wird
toolSetterHeight=0 # Hier die Höhe des WLS eintragen oder 0 wenn 3d Taster benutzt wird
# the absolute position of the Z axis of the probe contact for the reference tool
refToolProbePos = -60
# approach velocity (units/min)
vel =1000
# probing velocity (units/min)
fastProbeVel = fastProbeSpeed
slowProbeVel = slowProbeSpeed

# lift up dist before fine probing
goUpDist = 3
# delay (seconds) before fine probing
fineProbingDelay = 0.2
# other options
moveX = True
moveY = True
checkFineProbingDiff = True
fineProbeMaxAllowedDiff = 0.1
#############################################
###### END SETTINGS
#############################################



#############################################
# Macro START
#############################################
d.setSpindleState(SpindleState.OFF)
toolNr = d.getSpindleToolNumber()
if(toolNr == 0):
  sys.exit("Tool(0) has no tool lenght offset. Probing failed!")

# get current absolute position
pos = d.getPosition(CoordMode.Machine)

# start fast probing
pos[Axis.Z.value] =  pos[Axis.Z.value]-searcheDistance
probeResult = d.executeProbing(CoordMode.Machine, pos, probeIndex, fastProbeVel)
if(probeResult == False):
  sys.exit("fast probing failed!")
# get fast probe contact position
fastProbeFinishPos = d.getProbingPosition(CoordMode.Machine)

# lift-up Z
d.moveAxisIncremental(Axis.Z, goUpDist, vel)
# delay
time.sleep(fineProbingDelay)
# start fine probing
probeResult = d.executeProbing(CoordMode.Machine, pos, probeIndex, slowProbeVel)
if(probeResult == False):
  sys.exit("slow probing failed!")
# get fine probe contact position
probeFinishPos = d.getProbingPosition(CoordMode.Machine)

# check diff between fast and fine probing
probeDiff = abs(fastProbeFinishPos[Axis.Z.value] - probeFinishPos[Axis.Z.value])
if(probeDiff > fineProbeMaxAllowedDiff and checkFineProbingDiff == True):
  errMsg = "ERROR: fine probing difference limit exceeded! (diff: {:.3f})".format(probeDiff)
  sys.exit( errMsg)

print('sucess')
d.setAxisProgPosition(Axis.Z,0+toolSetterHeight)
d.moveAxisIncremental( Axis.Z, 5, fastProbeVel )



